C#LeetCode刷题之#888-公平的糖果交换(Fair Candy Swap)

版权声明:Iori 的技术分享,所有内容均为本人原创,引用请注明出处,谢谢合作! https://blog.csdn.net/qq_31116753/article/details/82505814

问题

爱丽丝和鲍勃有不同大小的糖果棒:A[i] 是爱丽丝拥有的第 i 块糖的大小,B[j] 是鲍勃拥有的第 j 块糖的大小。

因为他们是朋友,所以他们想交换一个糖果棒,这样交换后,他们都有相同的糖果总量。(一个人拥有的糖果总量是他们拥有的糖果棒大小的总和。)

返回一个整数数组 ans,其中 ans[0] 是爱丽丝必须交换的糖果棒的大小,ans[1] 是 Bob 必须交换的糖果棒的大小。

如果有多个答案,你可以返回其中任何一个。保证答案存在。

输入:A = [1,1], B = [2,2]

输出:[1,2]

输入:A = [1,2], B = [2,3]

输出:[1,2]

输入:A = [2], B = [1,3]

输出:[2,3]

输入:A = [1,2,5], B = [2,4]

输出:[5,4]

提示:

1 <= A.length <= 10000
1 <= B.length <= 10000
1 <= A[i] <= 100000
1 <= B[i] <= 100000
保证爱丽丝与鲍勃的糖果总量不同。
答案肯定存在。


Alice and Bob have candy bars of different sizes: A[i] is the size of the i-th bar of candy that Alice has, and B[j] is the size of the j-th bar of candy that Bob has.

Since they are friends, they would like to exchange one candy bar each so that after the exchange, they both have the same total amount of candy.  (The total amount of candy a person has is the sum of the sizes of candy bars they have.)

Return an integer array ans where ans[0] is the size of the candy bar that Alice must exchange, and ans[1] is the size of the candy bar that Bob must exchange.

If there are multiple answers, you may return any one of them.  It is guaranteed an answer exists.

Input: A = [1,1], B = [2,2]

Output: [1,2]

Input: A = [1,2], B = [2,3]

Output: [1,2]

Input: A = [2], B = [1,3]

Output: [2,3]

Input: A = [1,2,5], B = [2,4]

Output: [5,4]

Note:

1 <= A.length <= 10000
1 <= B.length <= 10000
1 <= A[i] <= 100000
1 <= B[i] <= 100000
It is guaranteed that Alice and Bob have different total amounts of candy.
It is guaranteed there exists an answer.


示例

public class Program {

    public static void Main(string[] args) {
        int[] A = { 1, 2, 5 }, B = { 2, 4 };

        var res = FairCandySwap(A, B);
        ShowArray(res);

        A = new int[] { 2 };
        B = new int[] { 1, 3 };
        res = FairCandySwap2(A, B);
        ShowArray(res);

        Console.ReadKey();
    }

    private static void ShowArray(int[] array) {
        foreach(var num in array) {
            Console.Write($"{num} ");
        }
        Console.WriteLine();
    }

    private static int[] FairCandySwap(int[] A, int[] B) {
        //此解法LeetCode超时未AC
        int sumA = A.Sum(), sumB = B.Sum();
        int diff = (sumB - sumA) / 2;
        for(int i = 0; i < A.Length; i++) {
            if(B.Contains(diff + A[i])) {
                return new int[] { A[i], diff + A[i] };
            }
        }
        return null;
    }

    private static int[] FairCandySwap2(int[] A, int[] B) {
        var diff = (A.Sum() - B.Sum()) / 2;
        var set = new HashSet<int>();
        foreach(var num in A) {
            set.Add(num);
        }
        foreach(var num in B) {
            if(set.Contains(num + diff)) {
                return new int[] { num + diff, num };
            }
        }
        return null;
    }

}

以上给出2种算法实现,以下是这个案例的输出结果:

5 4
2 3

分析:

FairCandySwap中 B.Contains 的执行时间为线性的  O(n) ,FairCandySwap2中的 set.Contains 因为使用的是哈希算法,其执行时间为常量时间c。即FairCandySwap的时间复杂度为 O(n^{2}) ,FairCandySwap2的时间复杂度为: O(n) 。

猜你喜欢

转载自blog.csdn.net/qq_31116753/article/details/82505814